class Field:
    @classmethod
    def of_range(cls, _min, _max, *addition):
        if _max == 255:
            _max = 254
            addition = ((255, 'MASK'), *addition)
        return (
            ('', ''), *((i, str(i)) for i in range(_min, _max + 1)),
            *addition)
    @classmethod
    def of_range_with_percent(cls, _min, _max, *addition):
        if _max == 255:
            _max = 254
            addition = ((255, 'MASK'), *addition)
        return (
            ('', ''), *((i, str(i) + " (" + (str(0) if i == 0 else str(round((10 ** ((i - 1) * 3 / 253 - 1)), 3))) + "%)") for i in range(_min, _max + 1)),
            *addition)

    @classmethod
    def of_boolean(cls): return ('', ''), ('true', 'On'), ('false', 'Off'),

    @classmethod
    def of_fade_time(cls): return (
        ('', ''), (0, 0.0), (1, 0.7), (2, 1.0), (3, 1.4), (4, 2.0), (5, 2.8), (6, 4.0), (7, 5.7), (8, 8.0), (9, 11.3),
        (10, 16.0), (11, 22.6), (12, 32.0), (13, 45.3), (14, 64.0), (15, 90.5),
    )

    @classmethod
    def of_fade_rate(cls): return (
        ('', ''), (1, 358), (2, 253), (3, 179), (4, 127), (5, 89.4), (6, 63.3), (7, 44.7), (8, 31.6), (9, 22.4),
        (10, 15.8), (11, 11.2), (12, 7.9), (13, 5.6), (14, 4.0), (15, 2.8),
    )

    @classmethod
    def of_dimming_curve(cls): return ('', ''), (0, 'Logarithmic'), (1, 'Linear'),

    @classmethod
    def of_event_priority(cls): return cls.of_range(2, 5)

    @classmethod
    def of_operating_mode(cls): return (
        ('', ''), (0, 'Standard'), *((i, '0x' + hex(i)[2:].rjust(2, '0').upper()) for i in range(0x80, 0xff + 1)))

    @classmethod
    def of_event_scheme(cls): return (
        ('', ''),
        (0, 'Type/Index'),
        (1, 'Address/Type'),
        (2, 'Address/Index'),
        (3, 'Group/Type'),
        (4, 'IGroup/Type'),
    )

    @classmethod
    def of_event_filter(cls): return (('', ''), *((i, bin(i)[2:].rjust(8, '0')) for i in range(0, 256)))

    @classmethod
    def of_instance_group(cls): return (('', ''), *((i, i) for i in range(0, 32)), (255, 'MASK'))

    @classmethod
    def _of_timer(cls, multiplier: (int, float), _min: int, _max: int, decimal=0, addition=()):
        return (('', ''), *addition, *((i, round(i * multiplier, decimal)) for i in range(_min, _max + 1)))

    @classmethod
    def of_dead_time(cls): return cls._of_timer(multiplier=0.05, _min=0, _max=255, decimal=2)

    @classmethod
    def of_report_time(cls): return cls._of_timer(multiplier=1, _min=0, _max=255)

    @classmethod
    def of_hold_time(cls): return cls._of_timer(multiplier=10, _min=0, _max=254)

    @classmethod
    def of_short_time(cls): return cls._of_timer(multiplier=0.02, _min=10, _max=255, decimal=2)

    @classmethod
    def of_double_time(cls): return cls._of_timer(multiplier=0.02, _min=10, _max=100, decimal=2)

    @classmethod
    def of_double_time_min(cls): return cls._of_timer(multiplier=0.02, _min=10, _max=100, decimal=2, addition=((0, 0),))

    @classmethod
    def of_repeat_time(cls): return cls._of_timer(multiplier=0.02, _min=5, _max=100, decimal=2)

    @classmethod
    def of_stuck_time(cls): return cls._of_timer(multiplier=1, _min=5, _max=255)
