from datetime import datetime

import can


from resh.protocols.can_utils.rapida2.r_bus2_packet import packet_from_can_message
from resh.utils import const
from resh.utils.settings import conf


class CanDumpHandler(can.Listener):
	def __init__(self):
		self.bus = can.Bus(channel=conf.interface, bustype=const.BUS_TYPE)

	def on_message_received(self, msg: can.Message):
		packet = packet_from_can_message(msg)
		print(f'{datetime.now().strftime("%M:%S.%f")[:-2]}: {packet.text_message()}')
