MODBUS_BOUNDS = [1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200, 230400, 460800, 921600]
MODBUS_PARITY = ['none', 'even', 'odd']

""" Адреса модулей """
BROADCAST = 0x00    # адрес 0 - широковещательная рассылка, при условии CMD=1
                    # адрес 1..29 - интерфейсные модули
POWER = 0x1e        # адрес 30 - блок питания
CONTROLLER = 0x1f   # адрес 31 - контроллер RAPIDA

""" Классы модулей """
CLASS_BROADCAST = 0x00
CLASS_DALI = 0x01
CLASS_MODBUS = 0x02
CLASS_DMX = 0x03
CLASS_RELAY = 0x04
CLASS_DALI_WIRELESS = 0x08
CLASS_G = 0x1e
CLASS_POWER = 0x1f

""" Типы модулей """
TYPES = {
    CLASS_BROADCAST:    dict(name='BRDCT', desc='Тип, принимаемый всеми модулями, при условии CMD=1'),
    CLASS_DALI:         dict(name='RPMDA', desc='Восьмиканальный модуль DALI'),
    CLASS_MODBUS:       dict(name='RPMMB', desc='Четырехканальный модуль Modbus'),
    CLASS_DMX:          dict(name='RPDMX', desc='Четырехканальный модуль DMX'),
    CLASS_RELAY:        dict(name='RPMRL', desc='Четырехканальный модуль реле'),
    CLASS_G:            dict(name='RPGDA', desc='Модуль распределенной периферии'),
    CLASS_POWER:        dict(name='RPCDA', desc='Встроенный в корпус контроллера модуль питания'),
    CLASS_DALI_WIRELESS: dict(name='R2MDAW', desc='DALI+'),
}
