import unittest
from unittest import TestCase

import resh.protocols.can_utils.rapida2.commands as r2commands


class TestR2Command(TestCase):

    def test_frame(self):
        cmd = r2commands.R2Command(*(0x1, 0x2))
        self.assertEqual(cmd.ext_bits, 0x3)

        cmd = r2commands.R2QueryVersion(*())
        self.assertEqual(cmd.ext_bits, 0)

        cmd = r2commands.R2QuerySerial(*[0x2])
        self.assertEqual(cmd.ext_bits, (1 << 6) + 0x02)

        cmd = r2commands.R2QueryIfaceTypes()
        self.assertEqual(cmd.ext_bits, 2 << 6)


if __name__ == '__main__':
    unittest.main()
